@echo off
REM Version 4.2 2015-03-12 - run from .\_ISO\docs\Make_E2B_USB_Drive folder (Uses LockDisMount), check for grubinst_new and new version of grubinst with silent-boot option, remove touchdrv.exe command, check 4K drives
cls
TITLE %~n0
:: set cmd shell window size
mode con: cols=120 lines=60
color 1f
echo Make an Easy2Boot USB drive (requires RMPrepUSB to be installed)
echo ================================================================
echo.
set str=%~dp0
set str=%str:~1,6%
if /i "%str%"==":\_ISO" echo ERROR: This drive is an E2B drive! Please run from a folder on your hard disk. & color 4f & pause & goto :EOF
set str=

call :check_Permissions
if "%ADMIN%"=="FAIL" goto :EOF

pushd "%~dp0"


echo.%~pn0 | find /I "Desktop\_ISO\docs\Make_e2b">nul && (set ERR=0) || (set ERR=1)
if "%ERR%"=="0" echo ERROR: Please extract the Easy2Boot files to an EMPTY FOLDER - not the Desktop! & color 4f & pause & goto :EOF
set ERR=

set str=%~dp0
set str=%STR:~-2,2%
if "%str%"==":\" echo ERROR: Source is a drive! Please run %~nx0 from the download folder & color 4f & pause & goto :EOF
set str=

if not exist ..\..\..\menu.lst echo ERROR: Cannot find Easy2Boot files in %~dp0 & color 4f & pause & exit
if not exist ..\..\e2b\grub\menu.lst echo ERROR: Cannot find Easy2Boot files in %~dp0 & color 4f & pause & exit
if not exist ..\..\e2b\grub\E2B_GRUB.txt echo ERROR: Cannot find Easy2Boot files in %~dp0 & color 4f & pause & exit

REM change to our working folder
set WF=%ProgramFiles(x86)%\RMPrepUSB
if exist "%WF%\rmpartusb.exe" goto :gotwf
set WF=%ProgramFiles%\RMPrepUSB
if exist "%WF%\rmpartusb.exe" goto :gotwf

:NF
echo.
echo Sorry - I cannot find RMPrepUSB!
echo Please install RMPrepUSB to your default Program Files folder
echo OR
echo Specify the folder where RMPrepUSB is located.
echo.
set /p WF=RMPrepUSB folder is at (e.g. D:\temp\RMPrepUSB) ? : 
if exist "%WF%\rmpartusb.exe" goto :gotwf
set /p ask=Sorry - couldn't find it - press R to Retry or any other key to exit (Retry\Abort) : 
if /i "%ask%"=="R" goto :NF
exit



:gotwf
set ALL=
set A=
pushd "%WF%"
RMPARTUSB FIND > %temp%\mdtemp.cmd
call %temp%\mdtemp.cmd > nul
if exist %temp%\mdtemp.cmd del %temp%\mdtemp.cmd > nul
if not "%DRIVESIZE%"=="0" goto :skipa
echo.
echo.
set /P A=WARNING: NO USB DRIVES DETECTED - DO YOU WANT TO LIST ALL THE DRIVES (Y/[N]) : 
if /I not "%A%"=="Y" goto :EOF
set ALL=ALLDRIVES
RMPARTUSB FIND %ALL% > %temp%\mdtemp.cmd
call %temp%\mdtemp.cmd > nul
if exist %temp%\mdtemp.cmd del %temp%\mdtemp.cmd > nul

:skipa
if "%DRIVESIZE%"=="0" color 4f & echo. & echo NO USB DRIVES FOUND! & pause & exit

REM list all USB drives so user can see them and their drive number
RMPARTUSB LIST  %ALL%
REM Ask user for a drive number
set /P DD=Please enter the USB drive number you want to ERASE and FORMAT (e.g. %DRIVE%) : 
REM execute RMPARTUSB (insert SURE if you don't want the user prompt)
cls
echo.
RMPARTUSB DRIVE=%DD% GETDRV %ALL% > %temp%\mdtemp.cmd
call %temp%\mdtemp.cmd > nul
if exist %temp%\mdtemp.cmd del %temp%\mdtemp.cmd > nul
if "%USBDRIVESIZE%"=="0" echo ERROR: NOT A USB DRIVE? & color 4f & pause & exit

:: check if 4K sector drive
wmic DISKDRIVE get caption, description, Deviceid, bytespersector | find "DRIVE%DD%" > %temp%\DD.tmp
find "4096" %temp%\DD.tmp > nul
if not errorlevel 1 color 4f & echo. & echo. & type %temp%\DD.tmp & echo. & echo SORRY: THIS DRIVE HAS 4K SECTORS AND IS NOT BOOTABLE! & echo. & pause & del %temp%\DD.tmp & goto :EOF
if exist %temp%\DD.tmp del %temp%\DD.tmp

cls
RMPARTUSB LIST %ALL%
if "%DD%"=="0" echo WARNING: DRIVE 0 IS YOUR SYSTEM DRIVE!!! & pause & exit
echo.
echo WARNING: ALL PARTITIONS ON DRIVE %dd% WILL BE DESTROYED...
echo.
set /p ask=Are you sure it is OK to format DRIVE %DD% (Y/N) : 
if /i not "%ask%"=="Y" exit
if "%DD%"=="0" exit

:lpf
cls
echo.
echo CHOOSE A FILESYSTEM 
echo ===================
echo.
echo NTFS  - If you want to boot from large files over 4GB 
echo FAT32 - If you have files below 4GB in size (most compatible)
echo.
set ask=
set /p ask=Format as FAT32 or NTFS? ([F=FAT32]/N=NTFS) : 
set FMT=FAT32
if /i "%ask%"=="N" set FMT=NTFS& goto :cc1
if "%ask%"=="" goto :cc1
if /i not "%ask%"=="F" goto :lpf
:cc1


echo.
echo ERASE AND FORMAT DRIVE %DD% as %FMT%...
RMPARTUSB DRIVE=%dd% CLEAN %ALL% > nul
if errorlevel 1 (color 4f & echo. & echo RMPARTUSB CLEAN COMMAND FAILED OR ABORTED BY USER - IF ERROR TRY AGAIN! & pause & exit)
REM delay to allow WIndows to see empty drive
RMPARTUSB DRIVE=%DD% GETDRV %ALL% > nul
RMPARTUSB DRIVE=%dd% WINPE %FMT% 2PTN %ALL% SURE VOLUME=E2B > nul
if errorlevel 1 (color 4f & echo RMPARTUSB COMMAND FAILED! & pause & exit)
echo Format complete - OK
set USBDRIVELETTER=
REM get the drive letter of the newly formatted drive
FOR /F "tokens=*" %%A IN ('RMPARTUSB DRIVE^=%dd% GETDRV %ALL%') DO %%A
If "%USBDRIVELETTER%"=="" goto :EOF



popd

if not exist ..\..\..\menu.lst exit
echo.
echo Copying over Easy2Boot files to %USBDRIVELETTER% - Please wait...
REM Only copy files in root, no subdirs; System Volume Information & $RECYCLE.BIN case problems with /herky
xcopy /hrky ..\..\..\*.* %USBDRIVELETTER%\*.* > nul
If errorlevel 1 color 4f & echo ERROR IN COPYING FILES & pause & exit
REM Copy _ISO subdir
xcopy /herky ..\..\..\_ISO\*.* %USBDRIVELETTER%\_ISO\*.* > nul
echo.
If errorlevel 1 color 4f & echo ERROR IN COPYING FILES & pause & exit

pushd "%WF%"

if "%dd%"=="0" exit

REM install grub4dos - use new grubinst to install to PBR
echo Installing grub4dos to PBR of %USBDRIVELETTER%...
set GR=grubinst.exe
REM check if silent-boot supported
if exist gr.txt del gr.txt
if exist gr1.txt del gr1.txt
%GR% -h 2> gr.txt
set SILENT=
find "--silent-boot" gr.txt > nul
if not errorlevel 1 set SILENT=--silent-boot
if "%SILENT%"=="" set GR=grubinst_new.exe


REM Dismount the drive, run grubinst, remount the drive
"%~dp0LockDismount.exe" -force %dd% %GR% -t=0 %SILENT% --install-partition=0 (hd%dd%) >> gr1.txt
If errorlevel 1 color 4f & pause & exit


REM #############################
REM use touchdrv to ensure MBR changes are not removed by Windows!  WARNING: causes some shell commands like FIND.exe to not work!!!!
REM touchdrv %USBDRIVELETTER% > nul
REM #############################

REM also install to MBR
echo.
echo Installing grub4dos to MBR of %USBDRIVELETTER%...
set GR=grubinst.exe
"%~dp0LockDismount.exe" -force %dd% %GR% -t=0 %SILENT% --skip-mbr-test (hd%dd%) >> gr1.txt
If errorlevel 1 color 4f & pause & exit

REM #############################
REM use touchdrv to ensure MBR changes are not removed by Windows!  WARNING: causes some shell commands like FIND.exe to not work!!!!
REM touchdrv %USBDRIVELETTER% > nul
REM #############################

if exist gr.txt del gr.txt
if exist gr1.txt del gr1.txt

popd

REM if it is not FAT32 the no point in having EFI folder for UEFI booting
if not "%FMT%"=="FAT32" if exist %USBDRIVELETTER%\EFI\nul rd /s /q %USBDRIVELETTER%\EFI > nul

REM delete this batch file from the USB drive
::echo Deleting %USBDRIVELETTER%\_ISO\docs\%~n0%~x0
::if exist %USBDRIVELETTER%\_ISO\docs\%~n0%~x0 del %USBDRIVELETTER%\_ISO\docs\%~n0%~x0


if exist %USBDRIVELETTER%\UPDATE_E2B_DRIVE.CMD del %USBDRIVELETTER%\UPDATE_E2B_DRIVE.CMD

REM Make new user MyE2B.cfg file
call "%~dp0Make_MyE2B.cfg.cmd" %USBDRIVELETTER%

echo.
color 2f
echo FINISHED - ALL OK.
echo.
pause
goto :EOF




:check_Permissions
    net session >nul 2>&1
    if not errorLevel 1 (
        echo Administrative permissions confirmed.
    ) else (
        echo Sorry - you need to run as Administrator [use right-click - Run as administrator].
		echo.
	color cf
	pause
	Set ADMIN=FAIL
    )
goto :eof

